<template>
  <q-card class="PopUpCard">
    <q-tabs v-model="tab" indicator-color="primary">
      <q-tab name="contacts" :label="$t('add_participant_form.contacts')" />
      <q-tab name="groups" :label="$t('add_participant_form.groups')" />
      <q-tab name="phone" :label="$t('add_participant_form.phone_number')" />
    </q-tabs>

    <q-separator></q-separator>

    <q-tab-panels v-model="tab" animated>
      <q-tab-panel name="contacts" class="q-pa-none">
        <!-- <h6 class="q-my-sm">
            {{ $t("add_participant_form.add_from_contacts") }}
          </h6> -->
        <q-list v-if="Object.keys(uninvitedContacts || {}).length != 0" separator>
          <q-item v-for="(contact, phoneNumber) in uninvitedContacts" :key="phoneNumber" clickable v-ripple @click="
            handleInviteParticipant(phoneNumber, {
              Moderator: false,
              Name: contact.Name,
            })
          ">
            <q-item-section>
              <q-item-label class="text-body1">
                {{ contact.Name }}
              </q-item-label>
              <q-item-label caption>
                {{ phoneNumber }}
              </q-item-label>
            </q-item-section>
            <q-item-section side>
              <q-icon name="add" />
            </q-item-section>
          </q-item>
        </q-list>
        <div v-else>{{ $t("add_participant_form.no_contacts") }}</div>
      </q-tab-panel>

      <q-tab-panel name="groups" class="q-pa-none">
        <q-list v-if="uninvitedGroups.length != 0" separator>
          <q-item v-for="group in uninvitedGroups" :key="group.Name" clickable v-ripple
            @click="handleInviteGroup(group)">
            <q-item-section>
              <q-item-label class="text-body1">
                {{ group.Name }}
              </q-item-label>
              <q-item-label caption>
                {{ group.List }}
              </q-item-label>
            </q-item-section>
            <q-item-section side>
              <q-icon name="add" />
            </q-item-section>
          </q-item>
        </q-list>
        <div v-else>{{ $t("add_participant_form.no_contacts") }}</div>
      </q-tab-panel>

      <q-tab-panel name="phone" class="q-pb-none">
        <!-- <h6 class="q-my-none">
          {{ $t("add_participant_form.add_from_phone_number") }}
        </h6> -->
        <InviteArbitraryNumber :usersPhone="user.Phone" :inviteParticipant="handleInviteParticipant"
          :participants="conference.Participants" />
      </q-tab-panel>
    </q-tab-panels>
  </q-card>
</template>
<script>
import Vue from "vue";
import InviteArbitraryNumber from "./InviteArbitraryNumber.vue";

export default {
  props: {
    user: {
      required: true,
    },
    conference: {
      required: true,
    },
    addParticipant: {
      required: true,
      // (phoneNumber: string, participant: { Name: string, Moderator: bool }) => void
    },
  },
  data()
  {
    return {
      tab: "contacts",
    };
  },
  computed: {
    uninvitedContacts()
    {
      if (
        this.user.Contacts === undefined ||
        this.conference.Participants === undefined
      )
        return;
      const contactsCopy = { ...this.user.Contacts };
      for (const phoneNumber in this.conference.Participants)
      {
        if (contactsCopy[phoneNumber] !== undefined)
        {
          Vue.delete(contactsCopy, phoneNumber);
        }
      }
      return contactsCopy;
    },
    uninvitedGroups()
    {
      const uninvited = Object.keys(this.uninvitedContacts);
      const listLength = 4;
      let toReturn = [];

      for (const groupName in this.user.Groups) 
      {
        let group = this.user.Groups[groupName];
        const members = Object.keys(group.Members);

        if (members.some(tel => uninvited.includes(tel)))
        {
          group.List = "";
          for (let i = 0; i < members.length; i++)
          {
            const name = this.user.Contacts[members[i]].Name;
            group.Members[members[i]] = name;
            if (i < listLength)
            {
              group.List += `${i > 0 ? ',' : ''} ${name}`;
            }
          }

          if (members.length > listLength) group.List += `, +${members.length - listLength}`
          toReturn.push(group)
        }
      }

      return toReturn;
    }
  },
  methods: {
    handleInviteParticipant(phoneNumber, participant)
    {
      this.addParticipant(phoneNumber, participant);
    },
    handleInviteGroup(group)
    {
      const uninvited = Object.keys(this.uninvitedContacts);
      for (const num in group.Members)
      {
        if (uninvited.includes(num)) this.addParticipant(num, {
          Moderator: false,
          Name: group.Members[num],
        });
      }
    }
  },
  components: {
    InviteArbitraryNumber,
  },
};
</script>
